// xsetaseta@gmail.com
//17/12/2015

#include <OneWire.h>

OneWire  ds(5);  //En pin 5 (una resistencia de 4.7K a Vcc)

#define DEBUG 0

// RX, TX    Para arduino normal

#include <SoftwareSerial.h>
SoftwareSerial mySerial(10, 11); 
#define SERIE8266 Serial
#define SERIECONSOLA mySerial  




//Para arduino mega
/*
#define SERIE8266 Serial3
#define SERIECONSOLA Serial
*/


#define MAXresponde  150
#define MAXmibuffer2  500

int time;
int contador;
char buffer[80]; 

char mibuffer2[MAXmibuffer2+1];    //ajustar al tamaño de la pagina web
char *puntero;
char responde[MAXresponde+1];
char sensores[5][10];


const int ledPin =  13;
const int ledReset =  12;


//  WIFI_SSID  WIFI_CLAVE 
prog_char cmd[]="AT+CWJAP=\"router\",\"password\"\r\n";  

prog_char Iniciohtml[]="HTTP/1.1 200 OK\r\n Content-Type: text/html\r\nConnection: close\r\n\r\n <!DOCTYPE HTML>\r\n <html>\r\n <TITLE>SERVER WEB Arduino + ESP8266 </TITLE>\r\n <big><b>Seta43_Arduino_ESP8266</b></big><br><hr> \r\n";

prog_char Finhtml[]="xsetaseta@gmail.com<br>\r\n </html>\r\n";



void setup()
  {  
   int z;

     pinMode(ledReset, OUTPUT);
     pinMode(ledPin, OUTPUT);
     digitalWrite(ledPin, LOW); delay(200);
     digitalWrite(ledReset, HIGH); delay(200);
     SERIECONSOLA.begin(9600);
     SERIE8266.begin(9600);     
   
     z=connectWiFi();
     SERIECONSOLA.print("ERRORES de conexion=");SERIECONSOLA.println(z);
     if(z>0)
       {
         digitalWrite(ledPin, LOW); delay(200); 
       }
       else
       { 
         digitalWrite(ledPin, HIGH); delay(200);
       }
     time=1;
     
  }


void loop()
{ 
  int ipd;
  int z;
  int tamano;
  
    if (SERIE8266.available())
         {           
         digitalWrite(ledPin, LOW); 
         z=mireadM(700); SERIECONSOLA.print(F("Bytes leidos="));  SERIECONSOLA.println(z);
         if(puntero=strstr(mibuffer2,"+IPD")) 
           {  SERIECONSOLA.println(F("Encontrado"));   z=puntero-mibuffer2;  }
         else
           { SERIECONSOLA.println(F("No_Encontrado")); z=0;   }
          
          if(z>0)
              {                           
                SERIECONSOLA.print(F("Encontrado +IPD en "));  SERIECONSOLA.println(z);
                SERIECONSOLA.print(F("IPD=")); ipd = mibuffer2[z+5]-48; SERIECONSOLA.println(ipd);
                if(ipd==0)paginaWeb(ipd);
              }
          digitalWrite(ledPin, HIGH);
         } 
  
     if (SERIECONSOLA.available())    SERIE8266.write(SERIECONSOLA.read());

    delay(1); time--;
    if(time<1)
      {       
       time=30000;
       //dectecta si sigue conectado
       
        if(!sendOrden("AT+CWJAP?\r\n","OK","conectado",200))
             if(connectWiFi())
               {
                 SERIECONSOLA.println("Reseteo HART");
                 digitalWrite(ledReset, LOW);
                 delay(800);
                 digitalWrite(ledReset, HIGH);            
               }
        
       //----------------------------
        for(contador=1;contador<5;contador++) strcpy(sensores[contador],"***");      
        for(contador=1;contador<5;contador++)
          {     
            if(0==getTemp())  break;              
            strcpy(sensores[contador],buffer);
            SERIECONSOLA.print(sensores[contador]);  SERIECONSOLA.print(" ");        
          }           
        SERIECONSOLA.println(" ");  
      }

}
   



int connectWiFi()
{
  int error;
    error=0;
    SERIECONSOLA.println(F("WIFI_CONECTAR"));   
    SERIE8266.println(F("AT+RST"));  mireadM(4000);
    if(!sendOrden("AT+CWMODE=1\r\n","OK","AT+CWMODE=1",200)) error++;    
    if(!sendOrden(cmd,"OK","setamodem2",2000)) error++;  
    if(!sendOrden("AT+CWMODE=3\r\n","OK","AT+CWMODE=3",200)) error++;    
    if(!sendOrden("AT+CIFSR\r\n","OK","AT+CIFSR",200)) error++; 
    SERIE8266.print("AT+CIFSR\r\n");   mireadR(300); SERIECONSOLA.println(responde);
    if(!sendOrden("AT+CIPMUX=1\r\n","OK","AT+CIPMUX=1",200)) error++;    
    if(!sendOrden("AT+CIPSERVER=1,80\r\n","OK","AT+CIPSERVER",200)) error++; 
    if(!sendOrden("AT+CIPSTO=8\r\n","OK","AT+CIPSTO=15",200)) error++; 
    SERIECONSOLA.println("FIN_WIFI"); 
    return(error);  
}

// orden AT, respuesta que deberia salir, mensaje de respuesta, retardo
int sendOrden(char *orden,char *respuesta, char *mensaje, int retardo)
{
 int zz;
  SERIE8266.print(orden);
   for(zz=0;zz<5;zz++)
     {
      mireadR(retardo); 
       if(strstr(responde,respuesta))
          { SERIECONSOLA.print("_ok_"); SERIECONSOLA.println(mensaje); return(1); } 
        else
          { SERIECONSOLA.print("_error_"); SERIECONSOLA.println(mensaje);  }
     }
  return(0);
}


int mireadM( int timeout)
{
  int z,zz;
  char c;
    z=0;

    while(timeout)
    {
      while(SERIE8266.available())
      {
        c = SERIE8266.read(); 
        if(z<MAXmibuffer2){ mibuffer2[z]=c; z++;}
      } 
     delay(1); timeout--; 
    }    
    #if DEBUG
      SERIECONSOLA.println("_"); 
      for(zz=0;zz<z;zz++) SERIECONSOLA.print(mibuffer2[zz]);
      SERIECONSOLA.println("DEBUG_readM_");
    #endif
    mibuffer2[z+1]=0;
  return z;
}


int mireadR( int timeout)
{
  int z,zz;
  char c;
    z=0;

    while(timeout)
    {
      while(SERIE8266.available())
      {
        c = SERIE8266.read(); 
        if(z<MAXresponde){ responde[z]=c; z++;}
      } 
     delay(1); timeout--; 
    }    
    #if DEBUG
      SERIECONSOLA.println("_"); 
      for(zz=0;zz<z;zz++) SERIECONSOLA.print(responde[zz]);
      SERIECONSOLA.println(F("DEBUG_readR_"));
    #endif
    responde[z+1]=0;
  return z;
}





 
  
boolean paginaWeb(int ipd)
{
  strcpy(mibuffer2,Iniciohtml);
  
  strcat(mibuffer2,"<big><big><font color=red><b>");
  for(contador=1;contador<5;contador++)
      {        
        sprintf(buffer,"%d",contador); strcat(mibuffer2,buffer);       
        strcat(mibuffer2,"&ordm;Sensor = ");         
        strcat(mibuffer2,sensores[contador]); 
        strcat(mibuffer2," &ordm;C\r\n<hr>");      
      } 
  
  strcat(mibuffer2,"</b></font></big></big><br>");

  strcat(mibuffer2,Finhtml);
  sendData(ipd);
  
}  
 


void sendData( int ipd)
{  
  int z,zz;
   SERIECONSOLA.println(F("INICIO_WEB"));
   z=strlen(mibuffer2);
   sprintf(buffer,"AT+CIPSEND=0,%d\r\n",z);
   
    #if DEBUG
       SERIECONSOLA.println(F("________INI__________"));
       SERIECONSOLA.println(buffer);
       SERIECONSOLA.println(F("============="));
       SERIECONSOLA.println(mibuffer2);
       SERIECONSOLA.println(F("============="));
       SERIECONSOLA.println(F("________FIN__________")); 
    #endif
    
  if(sendOrden(buffer,"> ",">>",300))
    {
      sendOrden(mibuffer2,"SEND OK","SEND",200);
      sendOrden("AT+CIPCLOSE=0\r\n","OK","AT+CIPCLOSE",200);
      SERIECONSOLA.println(F("FIN_WEB"));
    }
    else
    {
      SERIECONSOLA.println(F("ERROR_WEB"));
    }
}


//______________________________________________________
//ds18B20

int getTemp1()
{
   return 0;
}


int getTemp()
{
  byte data[12];
  byte addr[8];
  int z;
  long  temp;
  byte decimal;


  if ( !ds.search(addr))   { ds.reset_search(); return 0; }
  if ( OneWire::crc8( addr, 7) != addr[7])  { SERIECONSOLA.println(F("CRC is not valid!")); return -1; }
  if ( addr[0] != 0x10 && addr[0] != 0x28)  { SERIECONSOLA.print(F("Device is not recognized")); return -1; }

  ds.reset();  ds.select(addr);  ds.write(0x4E);         
  ds.write(0x4B);    
  ds.write(0x46);    
  ds.write(0x7F);    // 12-bit sampling resolution (default)
  //ds.write(0x5F);    // 11-bit
  //ds.write(0x3F);    // 10-bit
  //ds.write(0x1F);    // 9-bit
  // delay(500); 

  ds.reset();  ds.select(addr);  ds.write(0x44,1); // start conversion, with parasite power on at the end
  delay(750);  

  ds.reset();  ds.select(addr);  ds.write(0xBE); // Read Scratchpad
  for ( z = 0; z < 9; z++) data[z] = ds.read();
    
  z = (data[1] << 8) | data[0];
  temp=z;
  temp=(temp*625)/1000;
  z=temp/10;
  decimal=temp-z*10;
  sprintf(buffer,"%d,%d",z,decimal); 
  return 1;
  
}

